% CIS601 - Tom Gradel - Homework 6

% Clean up any old figures
close all;

% Number of images
IFIGURE = 6;
im = cell(IFIGURE,2); % Cell array for images

% Images are roughly the same sime, but trim images to this size
IROW = 135;
ICOL = 150;

% File names for textures
im{1,1} = 'grass.bmp';
im{2,1} = 'dirt.bmp';
im{3,1} = 'knit.bmp';
im{4,1} = 'hair.bmp';
im{5,1} = 'stones.bmp';
im{6,1} = 'plaid.bmp';

% load the images
for x=1:IFIGURE
    I = rgb2gray(imread(im{x,1}));
    im{x,2} = I([1:IROW],[1:ICOL]);
end 

% Show the images
for x=1:IFIGURE
    figure, imshow(im{x,1});  title ['figure: ', num2str(x)];
end

% Compute moments for each figure.
disp(sprintf('\n'));
for x = 1:IFIGURE
   phi = log(invmoments(im{x,2}));
   disp(sprintf('%s: %f ', im{x,1}, phi));
end

% Compute matrix of differences for first moment
for m = 1:7
    disp(sprintf('Index of closest images matching moment %d', m));
    d = ones(IFIGURE) .* 999;
    for x = 1:IFIGURE
        phiX = log(abs(invmoments(im{x,2})));
        mX = phiX(m);
        for y = 1:IFIGURE
            if (x ~= y)
                phiY = log(abs(invmoments(im{y,2})));
                mY = phiY(m);
                delta = mX - mY;
                d(x,y) = sum(delta .* delta);
            end
        end
    end
    
    % display the matrix of differences
    disp(d);
    [y,i] = min(d);
    for x = 1:IFIGURE
        disp(sprintf('%s is closest to %s', im{x,1}, im{i(x),1}));
    end
end    


